#include "ofApp.h"

//--------------------------------------------------------------
void ofApp::setup(){	
    //ENVIRONMENT
    ofBackground(0);
    //draw rectangles from center instead of upper left corner
    ofSetRectMode(OF_RECTMODE_CENTER);
    
    //VARIABLES
    //for (inital value; maxiumum value; increment)
    for (int i=0; i<numSquares; i++) {
        posX[i]=ofRandomWidth();
        posY[i]=ofRandomHeight();
        speedX[i]=ofRandom(1,8);
        speedY[i]=ofRandom(1, 8);
        touched[i]=false;
    }
}

//--------------------------------------------------------------
void ofApp::update(){
    for (int i=0; i<numSquares; i++) {
        if (!touched[i]) {//same as if(touched[i]==false; ! equals "not"
            posX[i]+=speedX[i];
            posY[i]+=speedY[i];
        }
        if (posX[i]<0 || posX[i]>ofGetWidth()) {
            //invert the speed if square position is outside the screen
            speedX[i]*=-1;//same as speedX[i]=-speedX[i];
        }
        if (posY[i]<0 || posY[i]>ofGetHeight()) {
            speedY[i]*=-1;
        }
    }
}

//--------------------------------------------------------------
void ofApp::draw(){
    
    for (int i=0; i<numSquares; i++) {
        if (!touched[i]) {
            ofSetColor(0, 0, 255,127);
        }else{
            ofSetColor(0, 255, 0, 127);
        }
        ofRect(posX[i], posY[i], 100, 100);
        if (i>0) {
            ofLine(posX[i], posY[i], posX[i-1], posY[i-1]);
        }
    }
    //to convert a number to a string use "ofToString"
    //"+" between strings adds strings together
    ofSetColor(255);
    ofDrawBitmapString("Frame Rate: "+ofToString(ofGetFrameRate()), 40,40);
}

//--------------------------------------------------------------
void ofApp::exit(){

}

//--------------------------------------------------------------
void ofApp::touchDown(ofTouchEventArgs & touch){
    touched[touch.id]=true;
    posX[touch.id]=touch.x;
    posY[touch.id]=touch.y;

}

//--------------------------------------------------------------
void ofApp::touchMoved(ofTouchEventArgs & touch){
    posX[touch.id]=touch.x;
    posY[touch.id]=touch.y;
}

//--------------------------------------------------------------
void ofApp::touchUp(ofTouchEventArgs & touch){
    touched[touch.id]=false;

}

//--------------------------------------------------------------
void ofApp::touchDoubleTap(ofTouchEventArgs & touch){

}

//--------------------------------------------------------------
void ofApp::touchCancelled(ofTouchEventArgs & touch){
    
}

//--------------------------------------------------------------
void ofApp::lostFocus(){

}

//--------------------------------------------------------------
void ofApp::gotFocus(){

}

//--------------------------------------------------------------
void ofApp::gotMemoryWarning(){

}

//--------------------------------------------------------------
void ofApp::deviceOrientationChanged(int newOrientation){

}
